/* C routine to filter out sensitive information in a course file. */
/* rows with such information are marked & in the first column.    */

// output goes to stdout

#include <stdio.h>

#define FNAME_PREFIX_LEN 18

main( int argc, char** argv )
{
  FILE *in;
  FILE *out = stdout;
  if (argc<=1) {
     fprintf(stderr,"Kfilter needs a parameter (file name)\n");
     exit(1);
  }
  in = fopen( argv[1], "r" );
  if (!in) {
     fprintf(stderr,"Kfilter cannot open file %s", argv[1]);
     exit(1);
  }
  fprintf(out, "<html><title>Course plans ABCD-und 2004</title><body bgcolor=white><h3>Course plan %s ABCD-und 2004</h3><p><pre>\n", argv[1] );
  while (!feof( in ))
  {
     int c = fgetc( in );
     // fprintf(stderr,"Kfilter reads %c = %d\n", c, (int) c );
     if (c=='\n') {  /* blank line */
        fputc( c, out );
        continue;
     }
     if (c=='&') {  /* sensitive comment line */
        int c2 = fgetc( in );
        while (!feof(in) && c2!='\n')
           c2 = fgetc( in );
     }
     else {  /* other line */
        int c2;
        fputc( c, out );
        if (feof(in))  break;
        c2 = fgetc( in );
        while (!feof(in) && c2!='\n') {
           fputc( c2, out );
           c2 = fgetc( in );
           if (feof(in))  break;
        }
        if (!feof(in))
           fputc( '\n', out );  /* \n */
     }
  }
  fprintf(out, "</pre></body>\n");
  exit(0);
}

