/* Sfilter.c */
/* C routine to filter out sensitive information in a plan file. */
/* Sensitive information is marked up by preceding $ + uppercase letter. */
/* the entire remainder of the line is removed. */

// output goes to stdout

#include <stdio.h>

main( int argc, char** argv )
{
  FILE *in;
  FILE *out = stdout;
  if (argc<=1) {
     fprintf(stderr,"Sfilter needs a parameter (file name)\n");
     exit(1);
  }
  in = fopen( argv[1], "r" );
  if (!in) {
     fprintf(stderr,"Sfilter cannot open file %s", argv[1]);
     exit(1);
  }
  while (!feof( in ))
  {
    int c2, c;
    c = fgetc( in );
    if (feof(in)) {  break; }
    if (c!='$') {
       fputc( c, out );
       continue;
    }
    else { // markup found
     fputc( '$', out );
     c2 = fgetc( in );
     if ( c2=='F'  // fdelsedag
       || c2=='T'  // timkostnad
       || c2=='P'  // totalkostnad
                   // ...
        ) {  // ignore the rest of this line:
        fputc( c2, out );
        while (!feof(in) && fgetc( in ) != '\n')   ;  // skip this
        fputc( '\n', out );
     }
     else fputc( c2, out ); // and continue;
    }
  }
  exit(0);
}

