/* C routine to accumulate lnekostnader fr en kurs */

#include <stdio.h>
#include <string.h>

#define salaryfilename "/home/chrke/StASy/2004/SALARYLIST"

#define MAXNName 500     // max number of staff entries

// file SALARYLIST contains rows 
//    @MyName blabla $T 123 kr

// convention: in course files, the last @MyName entry in a row
//             is the one that is credited the hours.
//             No more than 2 @-entries per row in a course file.

int NName = 0;
char *Name[MAXNName];
int Tcost[MAXNName];

void readname (FILE *in, char *name )
{
  char *p = name;
  while (!feof(in)) {
    int c = fgetc( in );
    if (isalpha(c) || c=='_')
      *p++ = c;
    else break;
  }
  *p++ = '\0';
  // fprintf(stderr,"...found %s\n", name);
}

void readTcost ( void )
{
  FILE *in;
  int k;
  in = fopen( salaryfilename,  "r" );
  if (!in) {
     fprintf(stderr,"readTcost cannot open file SALARYLIST");
     exit(1);
  }
  while (!feof( in ))
  {
   int c = fgetc( in );
   if (c=='/') {
     char *name = (char*) malloc(32);
     int j=0;
     while ((c=fgetc(in)) != EOF && c!=':' && c!='(')
       name[j++] = c;
     name[j] = '\0';
     // fprintf(stderr,"readTcost found name %s\n", name );
     if (NName>0 && strcmp(name, Name[NName-1])==0)  // already existing - overwrite T
        ; // do not enter a new name nor advance counter
     else
        Name[NName++] = name;
     while (!feof(in) && c!='\n') {
       c = fgetc( in ); 
       if (c=='$') {
        int k=0;
        int c2 = fgetc( in );
        if (c2=='T') {   // lnekost-info
          fscanf(in, "%d", &k);
          // fprintf(stderr," readTcost found salary cost %d kr/timme for %s at index %d\n", k, name, NName-1 );
          Tcost[NName-1] = k;
        }
        else {
          // fprintf(stderr," readTcost found no salary cost for %s at index %d\n", name, NName-1 );
          Tcost[NName-1] = 0;
        }
       }
     }
   }
 }
}



int findIndex ( char *s )
{
 int i;
 for (i=0; i<NName; i++ )
   if (strcmp(Name[i], s)==0) 
      return i;
 return -1;
}

main( int argc, char** argv )
{
  FILE *in;
  char *name = (char *) malloc(40);
  int Cost = 0;  // total work cost per year
  if (argc<=1) {
     fprintf(stderr,"addcost needs a parameter (course file name)\n");
     exit(1);
  }
  fprintf(stderr,"addcost %s\n", argv[1]);
  in = fopen( argv[1], "r" );
  if (!in) {
     fprintf(stderr,"addcost cannot open file %s", argv[1]);
     exit(1);
  }
  readTcost();
  while (!feof( in ))
  {
   int i;
   int c = fgetc( in );
   if (c=='@') {
     readname( in, name );
     // fprintf(stderr,"addcost found name %s\n", name );
     i = findIndex( name );
     if (i<0) {
        fprintf(stderr," addcost found no index for name %s\n", name );
        continue;
     }
     // fprintf(stderr," addcost found index %d for name %s\n", i, name );
     while (!feof(in) && c!='\n') {
       c = fgetc( in ); 
       if (c=='@') { // overrun previous @ name entry:
         readname( in, name );
         // fprintf(stderr,"addcost found new name %s\n", name );
         i = findIndex( name );
         if (i<0) {
            fprintf(stderr," addcost found no index for name %s\n", name );
            continue;
         }
         // fprintf(stderr," addcost found index %d for name %s\n", i, name );
       }
       if (c=='$') {
        int k=0;
        int c2 = fgetc( in );
        if (c2=='v' || c2=='h') {   // lnekost-contribution
          fscanf(in, "%d", &k);
          // fprintf(stderr," addcost found cost %d timmar at %d for %s\n", k, Tcost[i], name );
          Cost += k * Tcost[i];
        }
       }
     }
   }
  }
  fprintf(stdout, "Total cost lnekostnader:  %d kr\n", Cost );
  exit(0);
}

