/* C routine to compute Laurell formulas for a given number of students */

#include <stdio.h>
#include <string.h>

main( int argc, char** argv )
{
  int nst;
  float np, ntp;
  if (argc<=3) {
     fprintf(stderr,"lll needs 3 parameters\n");
     exit(1);
  }
  printf( "%s %s %s\n", argv[1], argv[2], argv[3] );
  sscanf( argv[1], "%d", &nst );
  if (nst <= 0) {
     fprintf(stderr,"lll parameter 1 (N.stud) must be a positive integer\n");
     exit(1);
  }
  sscanf( argv[2], "%f", &np );
  if (np <= 0) {
     fprintf(stderr,"lll parameter 2 (N.points) must be a positive float\n");
     exit(1);
  }
  sscanf( argv[3], "%f", &ntp );
  if (ntp < 0) {
     fprintf(stderr,"lll parameter 3 (N.tentapoints) must be a nonnegative float\n");
     exit(1);
  }
  if (ntp > np) {
     printf( "%d %f %f\n", nst, np, ntp );
     fprintf(stderr,"lll: tentapoints exceed course points\n");
     exit(1);
  }
  printf("Tidsanslag fr %d studenter:\n", nst);
  printf("Kursledning 20+%dst*%1.1fp*.1    =   %d h\n", nst, np, (int)(20+(nst*np)/10.0) );
  printf("Kursassistent 10+%dst*%1.1fp*.05 =   %d h\n", nst, np, (int)(10+(nst*np)/20.0) );
  printf("Examinator (setup/jour/visning)            %d h\n", (ntp>0)? 40:10);
  printf("Examination Tentarttning %dst*%1.1fp*.3 = %d h\n",
         nst, ntp, (int)(nst*ntp*0.3) );
  printf("Labtid total 4*(%d/2)*%1.1fp  =  %d h\n", nst, np-ntp, (int)(2.0*nst*(np-ntp)));
  exit(0);
}

