/* C routine to sum up integer numbers prefixed by $ in a file. */

#include <stdio.h>
#include <string.h>

#define FNAME_PREFIX_LEN 23

main( int argc, char** argv )
{
  FILE *in;
  FILE *out;
  char labstring[] = "      \0";
  int yhrs=-1; // yearly workhours (100% contract assumed)
  int yperc=-1;// yearly percentage of tjaenst
  int vsum=0; // spring
  int Vsum=0; // spring inkl otherexports (not paid by SaS-und)
  int hsum=0; // autumn
  int Hsum=0; // autumn inkl otherexports (not paid by SaS-und)
  int fddy=0; // year of birth
  int timk=0; // timkostnad
  int sum=0;  // total year
  int Sum=0;  // total year inkl otherexports
  int paysum = 0; // hours to be paid
  float scaling=1.0;  // time scaling factor to get rid of 40kr-skatt internally
  int fyrtiokr = 40;  // the kronor per hour to be dropped
  if (argc<=1) {
     fprintf(stderr,"sumup needs a parameter (file name)\n");
     exit(1);
  }
  /*fprintf(stderr,"sumup %s", argv[1]);*/
  in = fopen( argv[1], "r" );
  if (!in) {
     fprintf(stderr,"sumup cannot open file %s", argv[1]);
     exit(1);
  }
  while (!feof( in ))
  {
     int c = fgetc( in );
     if (c=='$') {
        int k=0;
        int c2 = fgetc( in );
        if (c2!='v' && c2!='h' && c2!='a' && c2!='y' 
            && c2!='p' && c2!='o' && c2!='T' && c2!='F'
            && c2!='V' && c2!='H') {
           fprintf(stderr, 
                   "sumup ERROR in %s: character v, h, a, p, y, V, H, T, F expected after $, found %c\n", argv[1], c2);
           exit(1);
        }
        if (c2=='o') {
           fscanf( in, "%6s", labstring );
        }
        else {
         fscanf(in, "%d", &k);
         switch (c2) {
           case 'a': Sum+=k; sum+=k; break;
           case 'v': Vsum+=k; vsum+=k; Sum+=k; sum+=k; break;
           case 'h': Hsum+=k; hsum+=k; Sum+=k; sum+=k; break;
           case 'p': yperc = k; break;
           case 'y': yhrs = k; break;
           case 'F': fddy = k; break;
           case 'T': timk = k; break;
           case 'V': Vsum+=k; Sum+=k; break;  // other export, not SaS-und
           case 'H': Hsum+=k; Sum+=k; break;  // other export, not SaS-und
           default: fprintf(stderr, "ERROR: sumup default case\n"); exit(1);
         }
        }
     }
  }
  if (yhrs==-1) {
     fprintf(stderr, "ERROR: yearly work hours not specified\n");
     exit(1);
  }
  if (yperc==-1) {
     fprintf(stderr, "WARNING: %s yearly percentage not specified\n", argv[1]);
  }
  if (yhrs>0 && yperc>0)   // Warning if > 3% vertid
     if (Sum > (int)(((float)(yperc+2)/100.0)*(float)yhrs))
        fprintf(stderr, "WARNING: %s mlvrdet f undervisning %d h verskridits: %d h\n",
                         argv[1], (int)(((float)yperc/100.0)*(float)yhrs), Sum );
  if (yhrs>0 && yperc>0)   // Warning if < 85% av yperc utlastad
     if (Sum < (int)(((float)(0.85*yperc)/100.0)*(float)yhrs))
        fprintf(stderr, "  -> TIPS:  %s outnyttjad underv-ressurs: %d timmar \n",
                         argv[1]+FNAME_PREFIX_LEN, (int)(((float)yperc/100.0)*(float)yhrs) - Sum );
  // Imports from SaS-labs: scale time to nullify 40kr-skatt:
  if ( ! strncmp(labstring,"XYLAB", 5)
   /*  ||! strncmp(labstring,"ZZLAB", 5) ... */  ) {
     scaling = (float)timk / (float)(timk + fyrtiokr);   // to scale down
  } 
  if ( ! strncmp(labstring,"ABCDUND",5) )
     // own staff must be paid their % anyway  .  No overtime!
     paysum = (int)(((float)yperc/100.0) * (float) yhrs);
  else
     paysum = sum;      // labs + extern: pay only by hours done
    
  argv[1][strlen(argv[1])-5] = '\0';
  fprintf(stdout,"%9s %6s 2004(%3d%%):%5dh =%3d%% / %4dh =%3d%% [LF%4dh] (vt%4dh [LF%4dh] =%3d%%/%3d%%%%,  ht%4dh [LF%4dh] =%3d%%/%3d%%%%) $P %6dkr\n", 
          argv[1]+FNAME_PREFIX_LEN,
          labstring,
          yperc,
          Sum, (int)(100.0*(float)Sum / (float) yhrs + 0.5), 
          paysum, (int)(100.0*(float)paysum / (float) yhrs + 0.5), 
	  (int)((float) paysum * scaling),
          Vsum, (int)((float)vsum * scaling),
                (int)(100.0*(float)Vsum / (float) yhrs + 0.5), 
                (int)(200.0*(float)Vsum / (float) yhrs + 0.5), 
          Hsum, (int)((float)hsum * scaling),
                (int)(100.0*(float)Hsum / (float) yhrs + 0.5),
                (int)(200.0*(float)Hsum / (float) yhrs + 0.5),
          (int)((float) paysum * scaling * (float) timk )
         );
  fprintf(stderr, "%s %s\n", argv[1]+FNAME_PREFIX_LEN, labstring );
  exit(0);
}

